/**
 * @fileDescription
 * Start a socket connection to local daemon server
 */

var request = require('request');

var path = require('path');
var Promise = require('bluebird');

exports.sendMessage = function sendMessage (type, data) {
    var def = this;
    data = data || {};
    var config = def.config;

    var dataObj = Array.isArray(type) ? type : {
        type: type,
        email: config.get('email'),
        mid: config.get('mid'),
        name: config.get('name'),
        _def_ver: def.version,
        message: data
    };


    return new Promise(function(resolve) {
        request.post(process.env.API_TRACK || 'http://api.def.taobao.net/track', {
            json: true,
            body: dataObj,
            timeout: 1000
        }, function(err, res){
            if (err) {
                def.log.warn('core', 'fail to send, error ', err.message);
                resolve(1);
            } else if (res.statusCode !== 200) {
                def.log.warn('core', 'fail to send code:', res.statusCode);
                resolve(2);
            } else {
                resolve(0);
            }
        });
    });

};

exports.sendCommand = function sendCommand() {
    var def = this;

    //format command
    var cmd = process.argv.slice(2);
    cmd.unshift('def');

    //send the command
    def.log.verbose('analytics', 'sending command');
    return def
        .sendMessage('command', {
            command: cmd.join(' ')
        });
};
