// def 守护进程
var path = require('path');
var fs = require('fs');

var defHome = process.env.DEF_HOME || '.';

process.title = 'defd';

var spawn = require('util-def').spawn;


var restartRemain = 20;
var resetTimer;


var stdio;

var debug = process.argv.indexOf('--print') > -1;

function run() {
    clearTimeout(resetTimer);

    var daemon = path.join(__dirname, 'child-main.js');

    var daemon2 = path.join(defHome, 'node_modules/def-cli/lib/daemon/child-main.js');

    var target = fs.existsSync(daemon2) ? daemon2 : daemon;

    var args = [target];

    if (debug) {
        args.push('--print');
    }

    var child = spawn('node', args, {
        stdio: 'inherit'
    });

    resetTimer = setTimeout(function(){
        restartRemain = 20;
    }, 1000 * 60 * 60);

    child.on('exit', function (code) {

        restartRemain -= 1;

        if (code === 0) {
            process.exit(0);
        }

        if (restartRemain <= 0) {
            console.error('reach restart limit;');
            process.exit(11);
        }

        run();
    });
}

run();