var path = require('path');
var Promise = require('bluebird');
var dUtil = require('util-def');
exports.start = start;

/**
 * start local daemon
 * @param {Object} def
 * @returns {Promise}
 */
function start(def) {
    return new Promise(function(resolve, reject) {
        console.log('starting...');

        process.env.REMOTE_PORT = process.env.REMOTE_PORT || 51999;
        process.env.LOCAL_PORT = process.env.LOCAL_PORT || 38555;
        process.env.DEF_VERSION = def.version;
        process.env.REMOTE_HOST = process.env.REMOTE_HOST || 'def.taobao.net';
        process.env.DEF_HOME = process.env.DEF_HOME || def.home;

        var childScript = path.join(__dirname, 'child.js');

        if (process.platform === 'win32') {
            var service = require('../service');
            return service.install(def).then(function(){
                def.log.info('install successful!');
                resolve();
            }, reject);
        } else {
            var child = dUtil.spawn(process.argv[0], [childScript], {
                stdio: 'ignore',
                detached: true,
                cwd: def.home
            });

            child.unref();

            //wait service to start
            setTimeout(resolve, 1000);
        }

    });
}