#!/usr/bin/env node
var path = require('path');
var fs = require('fs');
var rimraf = require('rimraf');
var dUtil = require('util-def');

var program = require('../lib/util/commander');
var pkg = require('../package.json');

var def = {
    version: pkg.version,
    home: dUtil.system.getUserHome('.def'),
    log: dUtil.log,
    install: dUtil.install
};

def.log.level = -1;

program.version(pkg.version);


program
    .command('rmsvc')
    .description('remove windows svc')
    .action(function(){
        var service = require('../lib/service');
        service.uninstall(def).then(function(){
            def.log.info('uninstall successful');
        }, def.fatal);
    });


program
    .command('installsvc')
    .description('remove windows svc')
    .action(function() {
        var service = require('../lib/service');
        service.install(def).then(function(){
            def.log.info('install successful');
        }, def.fatal);
    });

program.command('clean')
    .description('uninstall def')
    .action(function() {
        rimraf(def.home, function(err){
            if (err) {
                console.log(err);
            }
            if (err.stack) {
                console.log(err.stack);
            }
            process.exit(1);
        });
    });

program.on('*', function (){
    program.help();
});

program.parse(process.argv);